\documentclass[10pt,fullscreen=true, bookmarks=false]{beamer}
\usepackage{fancyhdr}
\usepackage{lipsum}
\usepackage{amssymb}
\usepackage{bbm}
\usepackage{ucs}
\usepackage[utf8x]{inputenc}
\usepackage[english,russian]{babel}
\usepackage[T2A]{fontenc}
\usepackage{listings}
\usepackage{graphicx}
\usepackage{blindtext}
\usepackage{booktabs}
\usepackage{xcolor}
\usepackage{hyperref}
\usepackage{listings}

\usetheme{default}
\title{Lecture 1. RISC-V overview, assembler, calling conventions}

\author{I.~Gorban}

\date{Mipt (Ilab), 09.2020}

\begin{document}
\bgroup\obeylines

% 1-st page
\begin{frame}
\titlepage
\end{frame}


\begin{frame}[fragile]
\frametitle{Стековые машины}

Пример работы стековой машины:

\begin{table}[]
\begin{tabular}{lllll}
         & \# &  stack      &  contents      & leftmost = top:        \\ 
push A   & \# &             &                & A                      \\ 
push B   & \# &             & B              & A                      \\ 
push C   & \# & C           & B              & A                      \\ 
subtract & \# &             & B - C          & A                      \\ 
multiply & \# &             &                & A*(B-C)                \\ 
push D   & \# &             & D              & A*(B-C)                \\ 
push E   & \# & E           & D              & A*(B-C)                \\ 
add      & \# &             & D+E            & A*(B-C)                \\ 
add      & \# &             &                & A*(B-C)+(D+E)          \hline 
\end{tabular}
\end{table}

Из преимуществ - стековым машинам не нужны операнды и они простые в реализации.

Пример использования - Java virtual machine, WebAssembly bytecode, Adobe's PostScript.

Вопрос - какие у них недостатки?

\tableofcontents[pausesections]
\end{frame}


\begin{frame}[fragile]
\frametitle{RISC-V isa}


Базовый набор ISA - для 32-бит - RV32I (RV32E - для embedded), для 64-бит - RV64I (RV64E - для embedded), для 128-бит - RV128I.

Эти наборы созданны как минимальные для поддержания в компиляторах.

\ 

Using in GNU  `-march=ISA-string`

Generate code for given RISC-V ISA (e.g. ‘rv64im’). ISA strings must be lower-case. Examples include ‘rv64i’, ‘rv32g’, ‘rv32e’, and ‘rv32imaf’.


\tableofcontents[pausesections]
\end{frame}



\begin{frame}[fragile]
\frametitle{RISC-V isa basic extensions}


Базовая ISA имеет возможность быть расширенна любым из следующих расширений:

- M	Целочисленное умножение и деление (Integer Multiplication and Division)

- A	Атомарные операции (Atomic Instructions)

- F	Арифметические операции с плавающей запятой над числами одинарной точности (Single-Precision Floating-Point)

- D	Арифметические операции с плавающей запятой над числами двойной точности (Double-Precision Floating-Point)

- G	Сокращеное обозначение для базового комплекта -> MAFD

Example: https://godbolt.org/z/GecMG7
 (rv32i <-> rv32im)

\tableofcontents[pausesections]
\end{frame}


\begin{frame}[fragile]
\frametitle{X86 and ARM extensions examples}

\ 
X86 extensions(totally over 40):

- MMX SIMD instructions
- 3DNow! SIMD extension for manipulating single-precision floating point
- SSE Streaming SIMD Extensions, SIMD for single-precision floating point
- AVX Advanced Vector Extensions, introduces 256-bits integer operations
- AVX-512 512 bit register operations

Backwards compatibility: Generally speaking, all extensions are supported from their introductory date to present day.

\ 

\ 

ARM extensions(totally over  8):

- Thumb (redused instructions size)
- VFP - vector floating point (removed after neon)
- Neon - Advanced SIMD (supports up to 16 operations at the same time)
- Jazelle - direct java bytecode execution
- ThumbEE - (Execution Environment) thumb for jit-compiler and bytecode execution

\tableofcontents[pausesections]
\end{frame}


\begin{frame}[fragile]
\frametitle{RISC-V isa additional extensions }

	
- Q	Арифметические операции с плавающей запятой над числами четвертной точности

- L	Арифметические операции над десятичными числами (Decimal Floating-Point)

- C	Сокращённые имена для команд (Compressed Instructions)

- B	Битовые операции (Bit Manipulation)

- J	Двоичная трансляция и поддержка динамической компиляции (Dynamically Translated Languages)

- T	Транзакционная память (Transactional Memory)

- P	Короткие SIMD-операции (Packed-SIMD Instructions)

- V	Векторные расширения (Vector Operations)

- N	Инструкции прерывания (User-Level Interrupts)

- H     Гипервизор для нативной виртуализации (Standard Extension for Hypervisor)

- ZiCSR Регистр состояния - Control and Status Register (CSR)

- Zifencei(Instruction-Fetch Fence)+Zam(Misaligned Atomics)+Ztso(Total Store Ordering)

В 32-битных микроконтроллерах и для других встраиваемых применений используется набор RV32EC. В 64-битных процессорах - RV64GC (в полной записи – RV64IMAFDC).

\tableofcontents[pausesections]
\end{frame}


\begin{frame}[fragile]
\frametitle{RISC-V registers}

RV32I:
Регистры - x0(zero), x1-x31 (32bit) + pc

RV32IF(D): f0-f31 + fcsr (control and status)

Обычно в ассемблере используются упрощенные наименования:

\ 
\ 


\resizebox{\columnwidth}{!}{%
\begin{table}[]
\begin{tabular}{llll}
Numeric & ABI name & Meaning                          & Saver  \\
x0      & zero     & Hard-wired zero                  & n/a    \\
x1      & ra       & Return address                   & Caller \\
x2      & sp       & Stack pointer                    & Callee \\
x3      & gp       & Global pointer                   & n/a    \\
x4      & tp       & Thread pointer                   & n/a    \\
x5-x7   & t0-t2    & Temporary registers              & Caller \\
x8-x9   & s0-s1    & Saved registers                  & Callee \\
x10-x11 & a0-a1    & Function arguments /return value & Caller \\
x12-x17 & a2-a7    & Function arguments               & Caller \\
x18-x27 & s2-s11   & Saved registers                  & Callee \\
x28-x31 & t3-t6    & Temporary registers              & Caller
\end{tabular}
\end{table}%
}

\tableofcontents[pausesections]
\end{frame}


\begin{frame}[fragile]
\frametitle{RISC-V Control instructions}

Calls:

- jal rd,offset - Jump to address and place return address in rd.

- jalr rd,rs1,offset - Jump to address and place return address in rd.


Branches:

- beq rs1,rs2,offset - Take the branch if rs1 == rs2

- bne rs1,rs2,offset - Take the branch if rs1 != rs2 

- blt rs1,rs2,offset - Take the branch if rs1 < rs2 (signed)

- bge rs1,rs2,offset - Take the branch if rs1 > rs2 (signed)

- bltu rs1,rs2,offset - Take the branch if rs1 < rs2 (unsigned)

- bgeu rs1,rs2,offset - Take the branch if rs1 > rs2 (unsigned)


Example: https://godbolt.org/z/bGvfYn (-O1)

\tableofcontents[pausesections]
\end{frame}


\begin{frame}[fragile]
\frametitle{RISC-V Memory instructions}

- lb rd,offset(rs1) - Loads a 8-bit value  and sign-extends this in rd.

- lh rd,offset(rs1) - Loads a 16-bit value and sign-extends this in rd.

- lw rd,offset(rs1) - Loads a 32-bit value and sign-extends this in rd.



- lbu rd,offset(rs1) - Loads  a 8-bit value and zero-extends this in rd.

- lhu rd,offset(rs1) - Loads a 16-bit value and zero-extends this in rd.


- sb rs2,offset(rs1) - Store 8-bit,  values from rs2 to memory.

- sh rs2,offset(rs1) - Store 16-bit, values from rs2 to memory.

- sw rs2,offset(rs1) - Store 32-bit, values from rs2 to memory.

Example:
lw ra, 4(sp) \# ra = Mem[sp + 4]


\tableofcontents[pausesections]
\end{frame}


\begin{frame}[fragile]
\frametitle{RISC-V 32I Arithmetic instructions immediate}

Only 12-bits immediate are avaliable. (real value = sign/unsign-extend 12-bit immediate)

- lui rd,imm - places the U-imm in the top 20 bits of rd, lowest 12 bits - zeros.

- addi rd,rs1,imm - Adds the sign-extended imm.

- slti rd,rs1,imm - Place "1" in rd if (sign)(rs1 < imm), else place "0".

- sltiu rd,rs1,imm - Place "1" in rd if (unsigb)(rs1 < imm), else place "0".

- xori rd,rs1,imm - XOR on rs1 and the sign-extended imm.

- ori rd,rs1,imm - OR on rs1 and the sign-extended imm.

- andi rd,rs1,imm - AND on rs1 and the sign-extended 12-bit imm.


- slli rd,rs1,shamt - Logical left shift rs1 by the shift amount held in the lower 5 bits of the imm.

- srli rd,rs1,shamt - Logical right shift rs1 by the shift amount held in the lower 5 bits of the imm.

- srai rd,rs1,shamt - Arithmetic(signed) right shift rs1 by the shift amount held in the lower 5 bits of the imm.

Example:
addi    s0,sp,32

\tableofcontents[pausesections]
\end{frame}


\begin{frame}[fragile]
\frametitle{RISC-V Arithmetic instructions register}

- add rd,rs1,rs2 - Adds the registers rs1 and rs2 and stores the result in rd.

- sub rd,rs1,rs2 - Subs the register rs2 from rs1 and stores the result in rd.

- sll rd,rs1,rs2 - Performs logical left shift on the value in register rs1 by the shift amount held in the lower 5 bits of register rs2.


- slt rd,rs1,rs2 - Place the value 1 in register rd if (rs1 < rs2) (signed), else 0 is written to rd.

- sltu rd,rs1,rs2 - Place the value 1 in register rd if (rs1 < rs2) (unsigned), else 0 is written to rd.

- xor rd,rs1,rs2 - Performs bitwise XOR on registers rs1 and rs2 and place the result in rd

- srl rd,rs1,rs2 - Logical right shift on the value in register rs1 by the shift amount held in the lower 5 bits of register rs2

- sra rd,rs1,rs2 - Performs arithmetic(signed) right shift on the value in register rs1 by the shift amount held in the lower 5 bits of register rs2.


- or rd,rs1,rs2 - Performs bitwise OR on registers rs1 and rs2 and place the result in rd.

- and rd,rs1,rs2 - Performs bitwise AND on registers rs1 and rs2 and place the result in rd.

Example: (https://godbolt.org/z/x1hnn6)
sll     a0, a0, a0

\tableofcontents[pausesections]
\end{frame}


\begin{frame}[fragile]
\frametitle{RISC-V Other instructions}

- auipc rd,imm - add upper immediate to pc. (x[rd] = pc + sext(immediate[31:12] << 12))

- fence pred, succ - Used to order device I/O and memory accesses as viewed by other RISC-V harts and external devices or coprocessors.

- fence.i (no-ops) - Provides explicit synchronization between writes to instruction memory and instruction fetches on the same hart.


- ecall (no-ops) - Make a request to the supporting execution environment. (EnvironmentCall)

- ebreak (no-ops) - Used by debuggers to cause control to be transferred back to a debugging environment. (RaiseException(Breakpoint))

\tableofcontents[pausesections]
\end{frame}




\begin{frame}[fragile]
\frametitle{RISC-V Pseudo instructions}

Псевдо-инструкции используются в ассемблере для упрощения понимания и простоты записи.
(RISC-V Instruction Set Manual: Chapter 25)


\resizebox{\columnwidth}{!}{%
\begin{table}[]
\begin{tabular}{lll}
Pseudo-instruction&
  Translation &
  Meaning \\
nop &
  addi x0,x0,0 &
  No operation \\
mv rd, rs &
  addi rd, rs, 0 &
  Copy register \\
not rd, rs &
  xori rd, rs, -1 &
  One’s complement \\
seqz rd, rs &
  sltiu rd, rs, 1 &
  Set if = zero \\
snez rd, rs &
  sltu rd, x0, rs &
  Set if != zero \\
ret &
  jalr x0, 0(x1) &
  Return from subroutine \\
call offset &
  \begin{tabular}[c]{@{}l@{}}auipc x1, offset{[}31 : 12{]} + offset{[}11{]}\\ jalr x1, offset{[}11:0{]}(x1)\end{tabular} &
  Call far-away subroutine \\
beqz rs, offset &
  beq rs, x0, offset &
  Branch if = zero \\
bgt rs, rt, offset &
  blt rt, rs, offset &
  Branch if \textgreater{} \\
lla rd, symbol &
  \begin{tabular}[c]{@{}l@{}}auipc rd, delta{[}31 : 12{]} + delta{[}11{]}\\ addi rd, rd, delta{[}11:0{]}\end{tabular} &
  \begin{tabular}[c]{@{}l@{}}Load local address,\\ where delta = symbol − pc\end{tabular} \\
l\{b|h|w|d\} rd, symbol &
  \begin{tabular}[c]{@{}l@{}}auipc rd, delta{[}31 : 12{]} + delta{[}11{]}\\ l\{b|h|w|d\} rd, delta{[}11:0{]}(rd)\end{tabular} &
  Load global \\
s\{b|h|w|d\} rd, symbol, rt &
  \begin{tabular}[c]{@{}l@{}}auipc rt, delta{[}31 : 12{]} + delta{[}11{]}\\ s\{b|h|w|d\} rd, delta{[}11:0{]}(rt)\end{tabular} &
  Store global
\end{tabular}
\end{table}%
}


\tableofcontents[pausesections]
\end{frame}




\begin{frame}[fragile]
\frametitle{RISC-V Calling conventions}

ABI(application binary interface) - набор соглашений для доступа приложения к операционной системе и другим низкоуровневым сервисам, спроектированный для переносимости исполняемого кода между машинами, имеющими совместимые ABI.

GNU RISC-V compiler позволяет задавать следующие ABI: «ilp32», «ilp32f», «ilp32d», «lp64», «lp64f» и «lp64d» (+ ilp32e для RV32E).

Различие состоит прежде всего в передаваемых float/double параметрах.

\ 

Стек растет вниз (от старших адресов к младшим), sp должен быть выравнен на границу 128-бит. Нет гарантии сохранения данных в стеке, расположенном на sp раньше входа в процедуру.

https://godbolt.org/z/hx44nK <-> https://godbolt.org/z/5rnxvh

* рассказать про callconv ARM (gnueabi + gnueabihf)

\tableofcontents[pausesections]
\end{frame}


\begin{frame}[fragile]
\frametitle{RISC-V Calling conventions: parameters}

Скалярные аргументы передаются в регистрах a0-a7.
Если регистров не хватает - параметры передаются через стек.
Если размер параметра превышает размер регистра целевой архитектуры - то он передается в паре регистров (или стека).
Так же большой параметр может передаваться частично в регистре, а частично в стеке.  
SP указывает на первый стековый параметр.

\ 

Возвращаемое значение записывается в тот же регистр, что и первый аргумент(например для ilp32 и int32\_t - r0, для lp64d и double - d0, для ilp32 и double - r0+r1+r2+r3). Если возвращаемое значение передается по ссылке - то вызывающий аллоцирует под него место на стеке и передаст адрес как неявный параметр. 

\ 

Вопрос к аудитории - что будет лежать относительно sp постаршим адресам? Что будет лежать по младшим?

Возврат к слайду RISC-V registers (callee/caller).

Example - https://godbolt.org/z/4Yhc5c


\tableofcontents[pausesections]
\end{frame}




\begin{frame}[fragile]
\frametitle{RISC-V links}

RISC-V ISA:
\url{https://github.com/riscv/riscv-isa-manual/releases/download/draft-20200727-8088ba4/riscv-spec.pdf}

RISC-V specification:
\url{https://riscv.org/technical/specifications/}

Education materials:
\url{https://riscv.org/community/learn-about-risc-v/educational-materials/}

Gnu compiler options:
\url{https://gcc.gnu.org/onlinedocs/gcc/RISC-V-Options.html}

Isa indexed:
\url{https://msyksphinz-self.github.io/riscv-isadoc/html/index.html}

Calling convention:
\url{https://github.com/riscv/riscv-elf-psabi-doc/}

ASM abi:
\url{http://kspt.icc.spbstu.ru/media/files/2018/lowlevelprog/riscv_asm_abi_2.pdf}

X86 extensions:
\url{https://en.wikichip.org/wiki/x86/extensions}

\tableofcontents[pausesections]
\end{frame}



\egroup
\end{document}
